// FoldCutDlg.cpp : Implementierungsdatei
//

#include <shlguid.h>
#include <shlobj.h>
#include "stdafx.h"
#include "FoldCut.h"
#include "FoldCutDlg.h"
#include "FolderBrowser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CFoldCutDlg Dialogfeld



CFoldCutDlg::CFoldCutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFoldCutDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFoldCutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CFoldCutDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_TARGETDIR, OnButtonTargetdirClicked)
	ON_BN_CLICKED(IDC_BUTTON_LINKDIR, OnButtonLinkdirClicked)
	ON_BN_CLICKED(IDOK, OnButtonOkClicked)
	ON_EN_CHANGE(IDC_EDIT_TARGETDIR, OnEditTargetdirChange)
	ON_EN_CHANGE(IDC_EDIT_LINKDIR, OnEditLinkdirChange)
	ON_EN_CHANGE(IDC_EDIT_LINKNAME, OnEditLinknameChange)
END_MESSAGE_MAP()


// CFoldCutDlg Meldungshandler

BOOL CFoldCutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	// TODO: Hier zustzliche Initialisierung einfgen
	CWinApp * pApp = AfxGetApp();
	if(pApp != NULL){
		CString sCmdLine = pApp->m_lpCmdLine;
		SetDlgItemText(IDC_EDIT_TARGETDIR, sCmdLine);
	}
	//
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CFoldCutDlg::OnPaint() 
{
	if (IsIconic())	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}else{
		CDialog::OnPaint();
	}
}
// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CFoldCutDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


// ************************************************************************************
// Browse for folders and other popular dialog activities
// ************************************************************************************
void CFoldCutDlg::OnButtonTargetdirClicked()
{
	CString sInitDir = "C:\\";
	GetDlgItemText(IDC_EDIT_TARGETDIR, sInitDir);
	CFolderBrowser browser("Select Target Folder:", sInitDir);
	if(browser.ShowDialog()){
		SetDlgItemText(IDC_EDIT_TARGETDIR, browser.GetPath());
	}
}
void CFoldCutDlg::OnButtonLinkdirClicked()
{
	CString sInitDir = "C:\\";
	GetDlgItemText(IDC_EDIT_LINKDIR, sInitDir);
	CFolderBrowser browser("Select Folder To Contain Shortcut:", sInitDir);
	if(browser.ShowDialog()){
		SetDlgItemText(IDC_EDIT_LINKDIR, browser.GetPath());
	}
}
void CFoldCutDlg::OnEditTargetdirChange()
{
	this->UpdateLinkName();
	this->UpdateButtons();
}
void CFoldCutDlg::OnEditLinkdirChange()
{
	this->UpdateButtons();
}
void CFoldCutDlg::OnEditLinknameChange()
{
	this->UpdateButtons();
}
void CFoldCutDlg::UpdateLinkName()
{
	CString sTargetDir = "";
	GetDlgItemText(IDC_EDIT_TARGETDIR, sTargetDir);
	if(sTargetDir != ""){
		int iLastBackSlash = sTargetDir.ReverseFind('\\');
		if(iLastBackSlash >= 0 && iLastBackSlash < sTargetDir.GetLength() - 1){
			CString sLinkName = sTargetDir.Mid(iLastBackSlash + 1);
			SetDlgItemText(IDC_EDIT_LINKNAME, sLinkName);
		}
	}
}
void CFoldCutDlg::UpdateButtons()
{
	CButton * pBtn = (CButton *) GetDlgItem(IDOK);
	if(pBtn != NULL){
		bool f = this->CheckInput();
		pBtn->EnableWindow(f);
	}	
}
bool CFoldCutDlg::CheckInput()
{
	CString sTargetDir = "", sLinkDir = "", sLinkName, sLinkFile = "";
	GetDlgItemText(IDC_EDIT_TARGETDIR, sTargetDir);
	GetDlgItemText(IDC_EDIT_LINKDIR, sLinkDir);
	GetDlgItemText(IDC_EDIT_LINKNAME, sLinkName);
	return (sTargetDir != "" && sLinkDir != "" && sLinkName != "");
}
void CFoldCutDlg::ShowError(const char * psz)
{
	AfxMessageBox(psz);
}


// ************************************************************************************
// Create
// ************************************************************************************
void CFoldCutDlg::OnButtonOkClicked()
{
	// check
	if(false == this->CheckInput()){
		this->ShowError("Input is faulty; this shouldn't even happen.");
		return;
	}
	// get dirs, names
	CString sTargetDir = "", sLinkDir = "", sLinkName, sLinkFile = "";
	GetDlgItemText(IDC_EDIT_TARGETDIR, sTargetDir);
	GetDlgItemText(IDC_EDIT_LINKDIR, sLinkDir);
	GetDlgItemText(IDC_EDIT_LINKNAME, sLinkName);
	if(sLinkDir.Right(1) == "\\"){
		sLinkFile = sLinkDir + sLinkName;
	}else{
		sLinkFile = sLinkDir + "\\" + sLinkName;
	}
	// say hello to COM
	HRESULT hres = CoInitialize(NULL);
	if(FAILED(hres)){
		this->ShowError("Can't initialize COM.");
		return;
	}
	// create FolderShortcut instance with IShellLink interface
	IShellLink* psl;
	hres = CoCreateInstance(CLSID_FolderShortcut, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (void**)&psl);
	if(FAILED(hres)){
		this->ShowError("Can't create instance of FolderShortcut supporting IShellLink.");
	}else{
		// query for IPersistFile interface
		IPersistFile* ppf;
		hres = psl->QueryInterface(IID_IPersistFile, (void**)&ppf);
		if (FAILED(hres)){
			this->ShowError("Can't get IPersistFile interface.");
		}else{
			// set target path
			hres = psl->SetPath(sTargetDir);
			if(FAILED(hres)){
				this->ShowError("IShellLink::SetPath failed.");
			}else{
				// save to link dir
				wchar_t wsz[MAX_PATH];
				MultiByteToWideChar(CP_ACP, 0, sLinkFile, -1, wsz, MAX_PATH);
				hres = ppf->Save((LPCOLESTR)wsz, TRUE);
				if(FAILED(hres)){
					this->ShowError("IPersistFile::Save failed.");
				}
			}
			// release IPersistFile
			ppf->Release();
		}
		// release IShellLink
		psl->Release();
	}
	// tell COM we're going away
	CoUninitialize();
	// so what?
	if(SUCCEEDED(hres)){
		// shell the folder
		ShellExecute(NULL, "explore", sLinkFile, NULL, NULL, SW_SHOWDEFAULT);
		// call base
		CDialog::OnOK();
	}
}

