#include "StdAfx.h"
#include "folderbrowser.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CFolderBrowser::CFolderBrowser(CString sMessage, CString sInitDir)
{
	m_Message = sMessage;
	m_InitDir = sInitDir;
}

CFolderBrowser::~CFolderBrowser()
{

}


//////////////////////////////////////////////////////////////////////
// Callback
//////////////////////////////////////////////////////////////////////
int CALLBACK BrowseCallbackProc (HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	switch(uMsg)
	{
		case 1:
			SendMessage (hwnd, BFFM_SETSELECTION, 1, lpData);
			break;
		default:
			break;
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////
// Methoden
//////////////////////////////////////////////////////////////////////
bool CFolderBrowser::ShowDialog()
{
	BROWSEINFOA bi;
	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = NULL;
	bi.lpszTitle = m_Message;
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = (CDECL BrowseCallbackProc);
	char chrSelPath[MAX_PATH]; char* pChrSelPath; pChrSelPath = chrSelPath;
	strcpy(pChrSelPath, m_InitDir);
	bi.lParam = (LPARAM)pChrSelPath;
	// call
	LPITEMIDLIST pidl =	SHBrowseForFolder(&bi);
	char chrPath[MAX_PATH]; char* lpPath; lpPath = chrPath;
	SHGetPathFromIDList(pidl, lpPath);
	m_Path = lpPath;
	// return
	return (m_Path.GetLength() > 0);
}
CString CFolderBrowser::GetPath()
{
	return m_Path;
}
